SoTextureCubeMap Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
SoTextureCubeMap Class Reference
Node Classes

The SoTextureCubeMap class is used to map a cube map onto subsequent shape nodes.Shape nodes within the scope of SoTextureCubeMap nodes in the scenegraph (ie below the same SoSeparator and to the righthand side of the SoTextureCubeMap) will have the texture applied according to each shape type's individual characteristics. See the documentation of the various shape types (SoFaceSet, SoCube, SoSphere, etc etc) for information about the specifics of how the textures will be applied. More...

`#include <Inventor/nodes/SoTextureCubeMap.h>`

Inherits SoTexture.

## Public Types
enum | Model { MODULATE = SoTextureImageElement::MODULATE, DECAL = SoTextureImageElement::DECAL, BLEND = SoTextureImageElement::BLEND, REPLACE = SoTextureImageElement::REPLACE }
enum | Wrap { REPEAT = SoTextureImageElement::REPEAT, CLAMP = SoTextureImageElement::CLAMP }

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoTextureCubeMap (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | rayPick (SoRayPickAction *action)

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
static SbBool | readImage (const SbString &fname, int &w, int &h, int &nc, unsigned char *&bytes)

## Public Attributes
SoMFString | filenames
SoSFImage | imagePosX
SoSFImage | imageNegX
SoSFImage | imagePosY
SoSFImage | imageNegY
SoSFImage | imagePosZ
SoSFImage | imageNegZ
SoSFEnum | wrapS
SoSFEnum | wrapT
SoSFEnum | model
SoSFColor | blendColor

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoTextureCubeMap ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | notify (SoNotList *list)
int | getReadStatus (void)
void | setReadStatus (int s)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)

## Detailed Description

The SoTextureCubeMap class is used to map a cube map onto subsequent shape nodes.

Shape nodes within the scope of SoTextureCubeMap nodes in the scenegraph (ie below the same SoSeparator and to the righthand side of the SoTextureCubeMap) will have the texture applied according to each shape type's individual characteristics. See the documentation of the various shape types (SoFaceSet, SoCube, SoSphere, etc etc) for information about the specifics of how the textures will be applied.

FILE FORMAT/DEFAULTS:

TextureCubeMap {
filenames [ ]
imagePosX 0 0 0
imageNegX 0 0 0
imagePosY 0 0 0
imageNegY 0 0 0
imagePosZ 0 0 0
imageNegZ 0 0 0
wrapS REPEAT
wrapT REPEAT
model MODULATE
blendColor 0 0 0
}

Since
  Coin 3.0

## Member Enumeration Documentation

enum SoTextureCubeMap::Model

Texture mapping model, for deciding how to "merge" the texturemap with the object it is mapped onto.

Enumerator
MODULATE | Texture color is multiplied by the polygon color. The result will be Phong shaded (if light model is PHONG).
DECAL | Texture image overwrites polygon shading. Textured pixels will not be Phong shaded. Has undefined behaviour for grayscale and grayscale-alpha textures.
BLEND | This model is normally used with monochrome textures (i.e. textures with one or two components). The first component, the intensity, is then used to blend between the shaded color of the polygon and the SoTextureCubeMap::blendColor.
REPLACE | Texture image overwrites polygon shading. Textured pixels will not be Phong shaded. Supports grayscale and grayscale alpha textures. This feature requires OpenGL 1.1. MODULATE will be used if OpenGL version < 1.1 is detected. Please note that using this texture model will make your Inventor files incompatible with older versions of Coin and Inventor. You need Coin >= 2.2 or TGS Inventor 4.0 to load Inventor files that uses the REPLACE texture model.

enum SoTextureCubeMap::Wrap

Enumeration of wrapping strategies which can be used when the texturemap doesn't cover the full extent of the geometry.

Enumerator
REPEAT | Repeat texture when coordinate is not between 0 and 1.
CLAMP | Clamp coordinate between 0 and 1.

## Constructor & Destructor Documentation

SoTextureCubeMap::SoTextureCubeMap | ( | void |  | ) |

Constructor.

SoTextureCubeMap::~SoTextureCubeMap | ( |  | ) |
| protectedvirtual

Destructor. Frees up internal resources used to store texture image data.

## Member Function Documentation

SoType SoTextureCubeMap::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Implements SoBase.

const SoFieldData * SoTextureCubeMap::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

void SoTextureCubeMap::doAction | ( | SoAction * | action | ) |
| virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

void SoTextureCubeMap::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method.

Reimplemented from SoNode.

void SoTextureCubeMap::callback | ( | SoCallbackAction * | action | ) |
| virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

void SoTextureCubeMap::rayPick | ( | SoRayPickAction * | action | ) |
| virtual

Action method for SoRayPickAction.

Checks the ray specification of the action and tests for intersection with the data of the node.

Nodes influencing relevant state variables for how picking is done also overrides this method.

Reimplemented from SoNode.

SbBool SoTextureCubeMap::readImage | ( | const SbString & | fname,
|  | int & | w,
|  | int & | h,
|  | int & | nc,
|  | unsigned char *& | bytes
| ) |  |
| static

Not implemented in Coin; should probably not have been public in the original SGI Open Inventor API. We'll consider to implement it if requested.

SbBool SoTextureCubeMap::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) |  |
| protectedvirtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

void SoTextureCubeMap::notify | ( | SoNotList * | l | ) |
| protectedvirtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

int SoTextureCubeMap::getReadStatus | ( | void |  | ) |
| protected

Returns read status. 1 for success, 0 for failure.

void SoTextureCubeMap::setReadStatus | ( | int | s | ) |
| protected

Sets read status.

See also
  getReadStatus()

## Member Data Documentation

SoSFString SoTextureCubeMap::filenames

The filenames in this order: negx, posx, negy, posy, negz, posz.

SoSFImage SoTextureCubeMap::imagePosX

The pos-x image.

SoSFImage SoTextureCubeMap::imageNegX

The neg-x image.

SoSFImage SoTextureCubeMap::imagePosY

The neg-y image.

SoSFImage SoTextureCubeMap::imageNegY

The neg-y image.

SoSFImage SoTextureCubeMap::imagePosZ

The pos-z image.

SoSFImage SoTextureCubeMap::imageNegZ

The neg-z image.

SoSFEnum SoTextureCubeMap::wrapS

Wrapping strategy for the S coordinate when the texturemap is narrower than the object to map onto.

Default value is SoTextureCubeMap::REPEAT.

SoSFEnum SoTextureCubeMap::wrapT

Wrapping strategy for the T coordinate when the texturemap is shorter than the object to map onto.

Default value is SoTextureCubeMap::REPEAT.

SoSFEnum SoTextureCubeMap::model

Texturemapping model for how the texturemap is "merged" with the polygon primitives it is applied to. Default value is SoTextureCubeMap::MODULATE.

SoSFColor SoTextureCubeMap::blendColor

Blend color. Used when SoTextureCubeMap::model is SoTextureCubeMap::BLEND.

Default color value is [0, 0, 0], black, which means no contribution to the blending is made.

The documentation for this class was generated from the following files:

- SoTextureCubeMap.h
- SoTextureCubeMap.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.